'=============================================================================
'
' unZix-Snippet-Tester.exe -- FREE and OPEN SOURCE -- by:  jimdunn (at) usa.net
'
' Compiled with PowerBasic Console Compiler 4.03 -- http://PowerBASIC.Com/
' I have no affiliation with PowerBASIC, except for being a satisfied customer.
'
' As I'm sure you already know, the WINZIX program is just a spyware scam, it
' doesn't even compress your files, it just concatenates them together with a
' few bytes at the top and a data region at the bottom of the new "zix" file.
'
' You should ONLY use the WinZix program if you WANT spyware on your computer.
' I have no affiliation with WinZix, except for writing unZix to unZix their Zix.
'
'=============================================================================

#COMPILE EXE
#DIM ALL

GLOBAL MyErrStr AS STRING

TYPE ZixArrayType
    zFolder AS STRING * 256
    zAttribute AS BYTE
    zFinish AS QUAD
    zName AS STRING * 256
    zSize AS QUAD
    zStart AS QUAD
END TYPE

FUNCTION ZixToArray(BYVAL a AS STRING, BYREF aa() AS ZixArrayType) AS LONG

    LOCAL x,y,t1,t2,aatot,dLen,folderLevel,folderTotal AS LONG
    LOCAL b,dKey,folderName,temp AS STRING
    DIM folderNames(0 TO 0) AS STRING

    IF LEFT$(a,1) <> "d" THEN
        FUNCTION = 1
        MyErrStr = "Error!  Invalid .ZIX file format (config data did not start with 'd')."
        EXIT FUNCTION
    END IF
    a = MID$(a,2)
    x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
    IF dKey = "announce" THEN
        x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
    ELSE
        FUNCTION = 1
        MyErrStr = "Error!  Invalid .ZIX file format (no 'announce' string)."
        EXIT FUNCTION
    END IF

    aatot = 0
    aa(aatot).zName = ""
    aa(aatot).zFolder = ""
    folderName = ""
    folderLevel = 0
    folderTotal = 0
    folderNames(folderTotal) = folderName
    DO
        IF LEN(a) = 0 THEN
            EXIT DO
        END IF

        IF INSTR(LEFT$(a,1), ANY "0123456789") THEN
            x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
            IF dKey = "files" THEN
                a = MID$(a,2)
            END IF
            IF dKey = "folders" THEN
                INCR folderLevel
                a = MID$(a,2)
            END IF
            ITERATE
        END IF

        IF LEFT$(a,1) = "d" THEN
            a = MID$(a,2)
            t1 = INSTR(a,"files")
            t2 = INSTR(a,"finish")
            IF t1 = 0 THEN
                t1 = 999999
            END IF
            IF t2 < t1 THEN
                INCR aatot
                REDIM PRESERVE aa(1 TO aatot)
                aa(aatot).zName = ""
                IF folderLevel THEN
                    aa(aatot).zFolder = STRING$(folderLevel,CHR$(255))
                ELSE
                    aa(aatot).zFolder = ""
                END IF
                FOR y = 1 TO 5
                    x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
                    IF dKey = "attribute" THEN
                        x = INSTR(a,"e") : aa(aatot).zAttribute = VAL(MID$(LEFT$(a,x-1),2)) : a = MID$(a,x+1)
                    END IF
                    IF dKey = "finish" THEN
                        x = INSTR(a,"e") : aa(aatot).zFinish = VAL(MID$(LEFT$(a,x-1),2)) : a = MID$(a,x+1)
                    END IF
                    IF dKey = "name" THEN
                        x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : aa(aatot).zName = LEFT$(a,dLen) : a = MID$(a,dLen+1)
                    END IF
                    IF dKey = "size" THEN
                        x = INSTR(a,"e") : aa(aatot).zSize = VAL(MID$(LEFT$(a,x-1),2)) : a = MID$(a,x+1)
                    END IF
                    IF dKey = "start" THEN
                        x = INSTR(a,"e") : aa(aatot).zStart = VAL(MID$(LEFT$(a,x-1),2)) : a = MID$(a,x+1)
                    END IF
                NEXT y
                IF LEFT$(a,1) = "e" THEN
                    a = MID$(a,2)
                ELSE
                    FUNCTION = 1
                    MyErrStr = "Error!  Invalid .ZIX file format (no 'e' following 'd')(1)."
                    EXIT FUNCTION
                END IF
            ELSE
                INCR folderTotal
                REDIM PRESERVE folderNames(0 TO folderTotal)
                x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
                IF dKey = "attribute" THEN
                    x = INSTR(a,"e") : temp = MID$(LEFT$(a,x-1),2) : a = MID$(a,x+1)
                END IF
            END IF
            ITERATE
        END IF

        IF LEFT$(a,1) = "l" THEN
            FUNCTION = 1
            MyErrStr = "Error!  Invalid .ZIX file format (found an extra 'l')."
            EXIT FUNCTION
        END IF

        IF LEFT$(a,1) = "e" THEN
            a = MID$(a,2)
            IF folderLevel THEN
                IF LEFT$(a,6) = "4:name" THEN
                    x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
                    IF dKey = "name" THEN
                        x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : folderName = LEFT$(a,dLen) : a = MID$(a,dLen+1)
                        folderNames(folderTotal) = folderNames(folderTotal-1) + folderName + "\"
                    END IF
                ELSE
                    FUNCTION = 1
                    MyErrStr = "Error!  Invalid .ZIX file format (did not find '4:name' after the 'e')."
                    EXIT FUNCTION
                END IF
                IF LEFT$(a,6) = "4:size" THEN
                    x = INSTR(a,":") : dLen = VAL(LEFT$(a,x-1)) : a = MID$(a,x+1) : dKey = LEFT$(a,dLen) : a = MID$(a,dLen+1)
                    IF dKey = "size" THEN
                        x = INSTR(a,"e") : temp = MID$(LEFT$(a,x-1),2) : a = MID$(a,x+1)
                    END IF
                ELSE
                    FUNCTION = 1
                    MyErrStr = "Error!  Invalid .ZIX file format (did not find '4:size' after the 'e')."
                    EXIT FUNCTION
                END IF
                DECR folderLevel
            ELSE
                temp = ""
            END IF
            ITERATE
        END IF
    LOOP

    FOR y = 1 TO UBOUND(aa())
        aa(y).zFolder = folderNames(LEN(TRIM$(aa(y).zFolder)))
    NEXT y
    FUNCTION = 0

END FUNCTION

FUNCTION PBMAIN() AS LONG

    DIM ZixArray(1 TO 1) AS ZixArrayType
    LOCAL y AS LONG
    LOCAL rs,j1,j2,j3,j4,j5,Sample AS STRING

    MyErrStr = "(none)"

    j1 = "d8:announce21:http://www.winzix.com5:filesld9:attributei0e6:finishi364080803e4:name31:Heroes.S01E23.HDTV.XviD-"
    j2 = "LOL.avi4:sizei364080792e5:starti11eed9:attributei0e6:finishi364091129e4:name9:codec.exe4:sizei10326e5:starti36408080"
    j3 = "3eed9:attributei0e6:finishi364181973e4:name30:Problems viewing the .AVI.html4:sizei1498e5:starti364180475eee7:folders"
    j4 = "ld9:attributei16e5:filesld9:attributei0e6:finishi364175867e4:name7:001.JPG4:sizei84738e5:starti364091129eed9:attribu"
    j5 = "tei0e6:finishi364180475e4:name9:Thumbs.db4:sizei4608e5:starti364175867eee4:name3:dat4:sizei0eeee"
    Sample = j1+j2+j3+j4+j5

    IF ZixToArray(Sample,ZixArray()) THEN
        STDERR MyErrStr
    ELSE
        FOR y = 1 TO UBOUND(ZixArray())
            STDOUT USING$("\    \ ######### ######### \                              \ ######### #########",ZixArray(y).zFolder,ZixArray(y).zAttribute,ZixArray(y).zFinish,ZixArray(y).zName,ZixArray(y).zSize,ZixArray(y).zStart)
        NEXT y
    END IF

    STDERR
    STDERR "Press any key to continue..."
    WAITKEY$

END FUNCTION
